#include<iostream>

#include<vector>

#include<string>

#include<algorithm>

using namespace std;





const int mod=998244353;

int n;

#define ll long long

//using ll = long long;

int dec(int a, int b)

{

    int bv = a - b;

    if (bv < 0)

    {

	bv += mod;

    }

    return bv;

}

int inc(int a, int b)

{

    int bv = a + b;

    if (bv > mod)

    {

	bv -= mod;

    }

    return bv;

}

int mlt(int a, int b)

{

    ll bv = ((ll)(a))*b;

    bv %= mod;

    return bv;

}

int pow(int a, int b)

{

    if(b == 0)

    {

	return 1;

    }

    if (b % 2 == 0)

    {

	int bv = pow(a, b / 2);

	return mlt(bv, bv);

    }

    int bv = pow(a, b -1);

    return mlt(bv, a);

}

int obr(int a)

{

    return pow(a, mod - 2);

}

vector<int>divisors, phi, odivisors;

int gcd(int a, int b)

{

    if (b == 0)

    {

	return a;

    }

    if (b > a)

    {

	return gcd(b, a);

    }

    return gcd(b, a%b);

}

void calc()

{

    for (int i = 1; i <= n; i++)

    {

	if (n%i == 0)

	{

	    divisors.push_back(i);

	    int sum = 0;

	    for (int j = 0; j < i; j++)

	    {

		if (gcd(i, j) == 1)

		{

		    sum++;

		}

	    }

	    phi.push_back(sum);

	    odivisors.push_back(obr(i));

	}

    }

}

vector<int> coef_to_vals(vector<int>coefs)

{

    vector<int>vals(divisors.size());

    vector<int>sums(divisors.size());

    for (int i = 0; i < divisors.size(); i++)

    {

	for (int j = i; j < divisors.size(); j++)

	{

	    if (divisors[j] % divisors[i] == 0)

	    {

		sums[i] = inc(coefs[j],sums[i]);

	    }

	}

    }

    for (int i = divisors.size()-1; i >=0; i--)

    {

	int d = divisors[i], sum = 0;

	sum = inc(sum, sums[divisors.size() - 1-i]);

	sum = mlt(sum, (divisors[divisors.size() - 1 - i]));

	for (int j = i + 1; j < divisors.size(); j++)

	{

	    if (divisors[j] % divisors[i] == 0)

	    {

		sum = dec(sum, vals[j]);

	    }

	}

	vals[i] = sum;

    }

    return vals;

}

vector<int> vals_to_coefs(vector<int>vals)

{

    vector<int>coefs(divisors.size());

    vector<int>sums(divisors.size());

    for (int i = 0; i < divisors.size(); i++)

    {

	for (int j = 0; j < divisors.size(); j++)

	{

	    if (divisors[j] % divisors[i] == 0)

	    {

		sums[i] =inc(vals[j],sums[i]);

	    }

	}

    }

    for (int i = divisors.size() - 1; i >= 0; i--)

    {

	int d = divisors[i], sum = 0;

	sum = inc(sum, sums[divisors.size() - 1 - i]);

	sum = mlt(sum, odivisors[i]);

	for (int j = i + 1; j < divisors.size(); j++)

	{

	    if (divisors[j] % divisors[i] == 0)

	    {

		sum = dec(sum, coefs[j]);

	    }

	}

	coefs[i] = sum;

    }

    return coefs;

}

int calc_rem(vector<int>v)

{

    int rem = 0;

    for (int i = 0; i < v.size(); i++)

    {

	rem = mlt(rem, 10);

	rem += v[i];

	rem %= n;

    }

    return rem;

}

int calc_pow(int a, vector<int>v)

{

//	cout << "CAL POW" << ' ' << a << ' ' << v[0] << ' ' << v[1] << endl;

    int rem = 0, ans = 1;

    for (int i = 0; i < v.size(); i++)

    {

    //	cout << i << ' '<<ans<<' '<<rem<<endl;

	ans = pow(ans, 10);

	rem *= 10;

	rem += v[i];

	ans = mlt(ans, pow(a, rem / n));

	rem %= n;

    }

    //cout << endl;

    return ans;

}

void stupid_mlt(vector<int>&v, int k)

{

    vector<int>bv(n);

    for (int i = 0; i < n; i++)

    {

	int j = i + k;

	if (j >= n)

	{

	    j -= n;

	}

	bv[j] = inc(v[i], v[j]);

    }

    v = bv;

}

int stupid_solve(int n, int ost, int val)

{

    vector<int> bv(n);

    bv[0] = 1;

    for (int i = 0; i < val; i++)

    {

	stupid_mlt(bv, i%n);

    }

    return bv[ost];

}

int main()

{

    calc();

    int ost;

    string s;

    cin >> n>>ost;

    cin >> s;

    int q;

    vector<int>bv(s.length());

    for (int i = 0; i < s.length(); i++)

    {

	bv[i]=s[i]-'0';

    }

    //cout << stupid_solve(n, ost, turns)<<endl;

    vector<int>pols(n);

    calc();

    pols[0] = 1;

    for (int i = 0; i < n; i++)

    {

	stupid_mlt(pols, i);

    }

    vector<int>coefs(divisors.size());

    for(int i=0; i<coefs.size(); i++)

    {

	coefs[i] = mlt(pols[divisors[i]%n], phi[divisors.size()-i-1]);

    }

    vector<int>vals = coef_to_vals(coefs);

    for (int i = 0; i<divisors.size(); i++)

    {

	vals[i] = mlt(vals[i], obr(phi[divisors.size()-1-i]));

	vals[i] = calc_pow(vals[i], bv);

	vals[i] = mlt(vals[i], phi[divisors.size()-1-i]);

    }

    coefs = vals_to_coefs(vals);

    for (int i = 0; i<coefs.size(); i++)

    {

	coefs[i] = mlt(coefs[i], obr(phi[divisors.size()-1-i]));

    }

    for (int i = 0; i < n; i++)

    {

	int g = gcd(i, n);

	for (int j = 0; j < divisors.size(); j++)

	{

	    if (divisors[j] == g)

	    {

		pols[i] = coefs[j];

	    }

	}

    }

    int rem = calc_rem(bv);

    for (int i = 0; i < rem; i++)

    {

	stupid_mlt(pols, i);

    }

    cout << pols[ost] << endl;

    cin >> n;

    return 0;

}
