#include <bits/stdc++.h>


using namespace std;


using ll = long long;


mt19937 mt(736);


const int mod = 998244353;


int find_ap(const vector<vector<int>> &gr, vector<int> &dep, vector<int> &fup, vector<bool> &ap,
            vector<vector<pair<int, int>>> &blocks, stack<pair<int, int>> &edges,
            int v, int par = -1)
{
	if (dep[v] != -1)
		return dep[v];

	dep[v] = par == -1 ? 0 : dep[par] + 1;
	fup[v] = dep[v];

	int cnt = 0;

	for (auto it : gr[v])
		if (it != par)
		{
			if (dep[it] == -1)
			{
				edges.emplace(v, it);
				cnt++;
				auto ch = find_ap(gr, dep, fup, ap, blocks, edges, it, v);
				fup[v] = min(fup[v], ch);
				if ((par != -1 && ch >= dep[v]) || par == -1)
				{
					ap[v] = true;
					blocks.emplace_back();

					while (blocks.back().empty() || blocks.back().back() != pair{v, it})
					{
						blocks.back().push_back(edges.top());
						edges.pop();
					}
				}
			}
			else
			{
				auto ch = find_ap(gr, dep, fup, ap, blocks, edges, it, v);
				fup[v] = min(fup[v], ch);
			}
		}

	if (par == -1)
		ap[v] = cnt > 1;

	return fup[v];
}


pair<int, int> foo(const vector<int> &siz, const vector<bool> &is_block, const vector<vector<int>> &gr,
                   int v, int par = -1)
{
	pair<int, int> ans = {1, is_block[v] ? siz[v] : 0};

	for (auto it : gr[v])
		if (it != par)
		{
			const auto q = foo(siz, is_block, gr, it, v);

			ans.first = ans.first * (q.first + (is_block[v] ? 0ll : 1ll)) % mod;
			ans.second += q.second;
			if (ans.second >= mod)
				ans.second -= mod;
		}

	if (!is_block[v])
	{
		ans.second += ans.first;
        ans.second %= mod;
	}

//	cerr << ans.first << ' ' << ans.second << endl;

	return ans;
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, m;

	cin >> n >> m;

	vector<vector<int>> gr(n);

	for (int i = 0; i < m; i++)
	{
		int a, b;

		cin >> a >> b;
		a--;
		b--;

		gr[a].push_back(b);
		gr[b].push_back(a);
	}

	vector<bool> ap(n);
	vector<int> dep(n, -1), fup(n);
	stack<pair<int, int>> edges;
	vector<vector<pair<int, int>>> blocks;

	find_ap(gr, dep, fup, ap, blocks, edges, 0);

	if (!edges.empty())
	{
		blocks.emplace_back();

		while (!edges.empty())
		{
			blocks.back().push_back(edges.top());
			edges.pop();
		}
	}

	vector<int> apnames;
	apnames.reserve(count(ap.begin(), ap.end(), true));

	for (int i = 0; i < ap.size(); i++)
		if (ap[i])
			apnames.push_back(i);

	vector<int> siz(apnames.size(), 1);
	siz.reserve(apnames.size() + blocks.size());
	vector<bool> is_block(apnames.size() + blocks.size());
	fill(is_block.begin() + apnames.size(), is_block.end(), true);
	vector<vector<int>> gbap(apnames.size() + blocks.size());

	for (int i = 0; i < blocks.size(); i++)
	{
		unordered_set<int> vrt;

		for (auto it : blocks[i])
		{
			vrt.insert(it.first);
			vrt.insert(it.second);
		}

		for (auto it : vrt)
		{
			auto wh = lower_bound(apnames.begin(), apnames.end(), it);

			if (wh != apnames.end() && *wh == it)
			{
				gbap[wh - apnames.begin()].push_back(i + apnames.size());
				gbap[i + apnames.size()].push_back(wh - apnames.begin());
			}
		}

		siz.push_back(vrt.size() - gbap[i + apnames.size()].size());
	}

	if (apnames.empty())
	{
		if (gr.size() > 1)
			cout << gr.size() + 2 << endl;
		else
			cout << gr.size() + 1 << endl;
	}
	else
		cout << (foo(siz, is_block, gbap, 0).second + 1) % mod << endl;
}


void stress(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, m;

	cin >> n >> m;

	vector<vector<int>> gr(n);

	for (int i = 0; i < m; i++)
	{
		int a, b;

		cin >> a >> b;
		a--;
		b--;

		gr[a].push_back(b);
		gr[b].push_back(a);
	}

	vector<bool> used(gr.size());


	function<bool(unsigned, int)> dfs = [&](unsigned mask, int v)
	{
		if (used[v])
			return false;
		used[v] = true;
		if ((1u << v) & mask)
			return true;
		for (auto it : gr[v])
			if (dfs(mask, it))
				return true;

		return false;
	};

	int ans = 0;

	for (unsigned mask = 0; mask < (1u << min((size_t) 30, gr.size())); mask++)
	{
		bool good = true;

		for (int i = 0; good && i < gr.size(); i++)
			if ((1u << i) & mask)
			{
				fill(used.begin(), used.end(), false);
				used[i] = true;

				for (auto it : gr[i])
					if (((1u << it) & (unsigned) mask) == 0 && dfs(mask, it))
					{
						good = false;
						break;
					}
			}

		if (good)
			ans++;
	}

	cout << ans << endl;
}


void gen(ostream &cout = std::cout)
{
	const int n = 7, m = 10;

	static_assert(n - 1 <= m);
	static_assert(m <= n * (n - 1ll) / 2);

	cout << n << ' ' << m << endl;

	unordered_set<ll> used;
	uniform_int_distribution<int> uid(1, n);

	for (int i = 2; i <= n; i++)
	{
		uniform_int_distribution<int> par(1, i - 1);

		int p = par(mt);

		used.insert(p * (ll) n + i);

		cout << p << ' ' << i << endl;
	}

	while (used.size() < m)
	{
		int a = 0, b = 0;

		while (a >= b || used.count(a * (ll) n + b))
		{
			a = uid(mt);
			b = uid(mt);
		}

		cout << a << ' ' << b << endl;

		used.insert(a * (ll) n + b);
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	int cnt = 0;

	while (true)
	{
		stringstream ss, in1, in2, out1, out2;

		gen(ss);

		in1 << ss.str();
		in2 << ss.str();

		solve(in1, out1);
		stress(in2, out2);

		if (out1.str() != out2.str())
		{
			cout << "fail: " << cnt << endl;

			cout << ss.str() << endl;
			cout << "solve" << endl;
			cout << out1.str() << endl;
			cout << "stress" << endl;
			cout << out2.str() << endl;

			break;
		}
		else if (++cnt % 100 == 0)
			cout << "ok: " << cnt << endl;
	}

	cout << "clock: " << setprecision(4) << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
