#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
using namespace std;

const int inf = int(1e9);

void remin (int &a, int b)
{
    a = min(a, b);
}
void remax (int &a, int b)
{
    a = max(a, b);
}

struct segtree
{
    int tsz;
    vector<int> vals;

    segtree (int n)
    {
        tsz = 1;
        while (tsz < n)
            tsz *= 2;

        vals.assign(2 * tsz, -inf);
    }

    void put (int pos, int what)
    {
        vals[pos += tsz] = what;
        for (pos >>= 1; pos > 0; pos >>= 1)
            vals[pos] = max(vals[2 * pos], vals[2 * pos + 1]);
    }

    int get_max (int l, int r)
    {
        int ans = -inf;
        for (l += tsz, r += tsz; l < r; l >>= 1, r >>= 1)
        {
            if (l & 1)
                remax(ans, vals[l++]);
            if (r & 1)
                remax(ans, vals[--r]);
        }
        return ans;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
#endif // LOCAL

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> es(m);
    vector<vector<int>> g(n);

    for (auto &e : es)
    {
        cin >> e.first >> e.second;
        --e.first, --e.second;
        g[e.first].push_back(e.second);
        g[e.second].push_back(e.first);
    }

    vector<int> par(n, -1), h(n), jump(n, inf), vertexjump(n, inf), maxbrotherjump(n, -inf), minexcljump(n, inf);
    vector<int> in(n), out(n);
    vector<vector<int>> sons(n);

    vector<char> used(n);
    int tmr = 0;

    function<void(int)> dfs = [&] (int x)
    {
        in[x] = tmr++;
        used[x] = 1;

        for (int dest : g[x])
        {
            if (!used[dest])
            {
                h[dest] = h[x] + 1;
                par[dest] = x;
                sons[x].push_back(dest);
                dfs(dest);
            }
            else if (dest != par[x])
                remin(vertexjump[x], h[dest]);
        }

        out[x] = tmr;

        jump[x] = vertexjump[x];
        for (int dest : sons[x])
            remin(jump[x], jump[dest]);

        {
            int max1 = -inf, max2 = -inf;
            for (int dest : sons[x])
            {
                if (max1 < jump[dest])
                {
                    max2 = max1;
                    max1 = jump[dest];
                }
                else if (max2 < jump[dest])
                    max2 = jump[dest];
            }

            for (int dest : sons[x])
                maxbrotherjump[dest] = (jump[dest] == max1 ? max2 : max1);
        }

        {
            int min1 = inf, min2 = inf;
            for (int dest : sons[x])
            {
                if (min1 > jump[dest])
                {
                    min2 = min1;
                    min1 = jump[dest];
                }
                else if (min2 > jump[dest])
                    min2 = jump[dest];
            }

            for (int dest : sons[x])
                minexcljump[dest] = min(jump[dest] == min1 ? min2 : min1, vertexjump[x]);
        }
    };

    dfs(0);

    const int bound = int(ceil(log2(n + 1)));
    vector<vector<int>> jumps(bound, vector<int>(n)), seg_minexcljump(bound, vector<int>(n));

    jumps[0] = par;
    jumps[0][0] = 0;
    seg_minexcljump[0] = minexcljump;

    for (int i = 1; i < bound; i++)
    for (int j = 0; j < n; j++)
    {
        jumps[i][j] = jumps[i - 1][jumps[i - 1][j]];
        seg_minexcljump[i][j] = min(seg_minexcljump[i - 1][j], seg_minexcljump[i - 1][jumps[i - 1][j]]);
    }

    segtree data(n);

    auto go_up = [&] (int v, int len)
    {
        for (int i = bound - 1; i >= 0; i--)
        if (len >= (1 << i))
        {
            v = jumps[i][v];
            len -= (1 << i);
        }

        assert(len == 0);
        return v;
    };

    auto get_midh = [&] (int v, int len)
    {
        if (len < 0)
            return -1;

        int ans = inf;
        for (int i = bound - 1; i >= 0; i--)
        if (len >= (1 << i))
        {
            remin(ans, seg_minexcljump[i][v]);
            v = jumps[i][v];
            len -= (1 << i);
        }

        assert(len == 0);
        return ans;
    };

    map<pair<int, int>, bool> answer;
    vector<vector<int>> at_height(n);
    for (int i = 0; i < n; i++)
        at_height[h[i]].push_back(i);

    for (int cur_height = 0; cur_height < n; cur_height++)
    {
        for (int v : at_height[cur_height])
        {
            const auto &u = sons[v];
            const int k = int(u.size());

            vector<int> hjump (k), ljump (k);
            for (int i = 0; i < k; i++)
                hjump[i] = jump[u[i]];
            for (int i = 0; i < k; i++)
                ljump[i] = data.get_max (in[u[i]], out[u[i]]);


            vector<char> tom(k, 0), toh(k, 1);
            vector<pair<int, int>> evs_m, evs_h;
            int cnt_zero = 0, cnt_one = 0;

            for (int i = 0; i < k; i++)
            {
                evs_h.emplace_back(hjump[i], i);
                evs_m.emplace_back(ljump[i] - 1, i);
            }

            for (int it = 0; it < 2; it++)
            {
                auto &cur_evs = (it == 0 ? evs_m : evs_h);
                sort(cur_evs.begin(), cur_evs.end(), greater<pair<int, int>>());
            }

            sort(g[v].begin(), g[v].end(), [&] (int x, int y) {return h[x] > h[y];});

            int ptr_h = 0, ptr_m = 0;

            for (int r : g[v]) if (h[r] < h[v])
            {
                for (int it = 0; it < 2; it++)
                {
                    const auto &cur_evs = (it == 0 ? evs_h : evs_m);
                    auto &ptr = (it == 0 ? ptr_h : ptr_m);
                    auto &cur_to = (it == 0 ? toh : tom);
                    while (ptr < int(cur_evs.size()) && cur_evs[ptr].first >= h[r])
                    {
                        const int id = cur_evs[ptr++].second;
                        cnt_one -= (toh[id] == 1 && tom[id] == 1);
                        cnt_zero -= (toh[id] == 0 && tom[id] == 0);
                        cur_to[id] ^= 1;
                        cnt_one += (toh[id] == 1 && tom[id] == 1);
                        cnt_zero += (toh[id] == 0 && tom[id] == 0);
                    }
                }

                const int l = int(sons[r].size());

                bool &result = answer[pair<int, int>(v, r)];

                const int s1 = go_up (v, h[v] - h[r] - 1);
                // ���� s1 == par[v] � h[v] - h[r] - 1 == 0, �� �������, ���� ����� midh
                const int midh = get_midh (v, h[v] - h[r] - 1);

                if (maxbrotherjump[s1] >= h[r] && (k > 0 || par[r] != -1 || par[v] != r || l >= 3))
                {
                    result = false;
                    continue;
                }

                // H = 0, M = 0
                if (par[r] == -1 && par[v] == r)
                    result = (k <= 1);
                // H = 0, M != 0
                else if (par[r] == -1 && par[v] != r)
                    result = (count(tom.begin(), tom.end(), 1) == k);
                // H != 0, M = 0
                else if (par[r] != -1 && par[v] == r)
                    result = (count(toh.begin(), toh.end(), 1) == k);
                // H != 0, M != 0
                else
                {
                    assert(par[r] != -1 && par[v] != r);

                    if (cnt_zero > 0)
                        result = false;
                    else if (cnt_one > 0 || midh < h[r])
                        result = true;
                    else
                        result = false;
                }
            }
        }

        for (int v : at_height[cur_height])
        {
            for (int dest : g[v]) if (h[dest] > h[v])
                data.put(in[dest], cur_height);
        }
    }

    string ans;
    for (int i = 0; i < m; i++)
    {
        int x, y;
        tie(x, y) = es[i];
        if (h[x] < h[y])
            swap(x, y);
        assert(h[x] > h[y]);

        ans += (answer.at(pair<int, int>(x, y)) ? '1' : '0');
    }

    cout << ans << endl;
}
