#include <bits/stdc++.h>


using namespace std;


using ll = long long;


mt19937 mt(736);


using pnt = complex<ll>;


istream &operator>>(istream &cin, pnt &p)
{
	int x, y;

	cin >> x >> y;

	p = {x, y};

	return cin;
}


ll dot_prod(const pnt &a, const pnt &b)
{
	return a.real() * b.real() + a.imag() * b.imag();
}


ll len2(const pnt &a)
{
	return dot_prod(a, a);
}


template<class T>
T sqr(const T &x)
{
	return x * x;
}


char solve(pnt teammate, pnt opponent, ll ball_speed, ll player_speed)
{
	if (ball_speed > player_speed)
	    return '+';

	auto median = opponent + teammate;

	teammate *= 2;
	opponent *= 2;
	ball_speed *= 2;
	player_speed *= 2;

	teammate -= median;
	opponent -= median;
	auto we = -median;
	// I use 'bound' as the upper bound of coordinates there, so it is doubled bound from statements

	if (len2(teammate - we) <= len2(opponent - we))
		return '+';

	auto vy = opponent;
	auto vx = vy * pnt(0, 1);

	auto change_basis = [&vx, &vy](const pnt &p) -> pnt {
		return {dot_prod(p, vx), dot_prod(p, vy)};
	};

	// 2 * bound^2
	opponent = change_basis(opponent);
	we = change_basis(we);
	
	if (ball_speed == player_speed)
        return we.real() == 0 && abs(we.imag()) > abs(opponent.imag()) ? '-' : '+';

	auto comp_diff = [&opponent, &we, &ball_speed, &player_speed]() -> ll {
		ll b2 = sqr(opponent.real() * sqr(ball_speed) - we.real() * sqr(player_speed)); // 16 * bound^8
		ll a = sqr(ball_speed) - sqr(player_speed); // 2 * bound^2
		ll c = len2(opponent) * sqr(ball_speed) -
		       len2(we) * sqr(player_speed); // 2 * (2 * (2 * bound)^2) * bound^2 = 16 * bound^4

		return b2 - a * c;
	};

	auto diff = comp_diff();

	return diff == 0 ? '0' : diff > 0 ? '+' : '-';
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	string ans(n, '?');

	for (auto &it : ans)
	{
		pnt tm, op;
		int bs, ps;

		cin >> tm >> op >> bs >> ps;

		it = solve(tm, op, bs, ps);
	}

	cout << ans << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << setprecision(4) << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
