#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

/// return poly(x) * (1 + x + ... x^(n - 1))
vector<bool> mult_by (const vector<bool> &poly, const int n)
{
	vector<bool> ans(int(poly.size()) + n - 1);
	bool cur = false;
	for (int i = 0; i < int(ans.size()); i++)
	{
		if (i < int(poly.size()))
			cur ^= poly[i];
		if (i >= n)
			cur ^= poly[i - n];
		ans[i] = cur;
	}
	return ans;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, k;
	while (cin >> n >> k)
	{
		vector<bool> ans = {true};
		for (int i = 1; i <= n; i++)
			ans = mult_by(ans, i);
		cout << int(ans[k]) << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
