
#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
vector<int>facts, ofacts;
const int mod = 998244353;
int add(int a, int b)
{
	int bv = a + b;
	if (a + b >= mod)
	{
		bv -= mod;
	}
	return bv;
}
int sub(int a, int b)
{
	int bv = a - b;
	if (bv < 0)
	{
		bv += mod;
	}
	return bv;
}
int mult(int a, int b)
{
	long long  bv = ((long long)(a)*b) % mod;
	return bv;
}
int bp(int a, int b)
{
	if (b == 0)
	{
		return 1;
	}
	if (b % 2 == 1)
	{
		int bv = bp(a, b - 1);
		return mult(bv, a);
	}
	int bv = bp(a, b / 2);
	return mult(bv, bv);
}
int rev(int a)
{
	return bp(a, mod - 2);
}
void calc()
{
	facts.resize(6100);
	ofacts.resize(6100);
	facts[0] = 1;
	ofacts[0] = 1;
	for (int i = 1; i < 6100; i++)
	{
		facts[i] = mult(facts[i - 1], i);
		ofacts[i] = rev(facts[i]);
	}
}
vector<int>sum_vec(vector<int> a, vector<int>b)
{
	vector<int>c(a.size());
	for (int i = 0; i < a.size(); i++)
	{
		c[i] = add(c[i], a[i] + b[i]);
	}
	return c;
}
vector<int>mlt_vec(vector<int> a, int b)
{
	vector<int>c(a.size());
	for (int i = 0; i < a.size(); i++)
	{
		c[i] = mult(a[i], b);
	}
	return c;
}
vector<int>mult_bypol(vector<int>vec, int c)
{
	int n = vec.size();
	vector<int>v(n + 1);
	for (int i = 0; i <= n; i++)
	{
		//	cout << "dddd" << ' ' << i << endl;
		if (i < n)
		{
			v[i] = mult(mod - c, vec[i]);
		}
		if (i > 0)
		{
			v[i] = add(v[i], vec[i - 1]);
		}
	}
	//cout << "Done" << endl;
	return v;
}
vector<int>divide(vector<int>vec, int c)
{
	if (vec.size() == 0)
	{
		return vec;
	}
	else
	{
		int n = vec.size();
		vector<int>bv(n - 1);
		bv[n - 2] = vec[n - 1];
		for (int i = n - 3; i >= 0; i--)
		{
			bv[i] = add(vec[i + 1], mult(bv[i + 1], c));
		}
		return bv;
	}
}
vector<int>interpolate(vector<int>vals)
{
	int n = vals.size();
	vector<int>lagr(1), c(n), ans(n), bv(n);
	lagr[0] = 1;
	for (int i = 0; i < n; i++)
	{
		lagr = mult_bypol(lagr, i);
		c[i] = mult(ofacts[i], ofacts[n - 1 - i]);
		c[i] = mult(c[i], vals[i]);
		if ((n - 1 - i) % 2 == 1)
		{
			c[i] = mod - c[i];
		}
	}
	for (int i = 0; i < n; i++)
	{
		bv = divide(lagr, i);
		bv = mlt_vec(bv, c[i]);
		ans = sum_vec(ans, bv);
	}
	return ans;
}
vector<int>getpol(int a)
{
	vector<int>ma;
	if (a < 0)
	{
		return ma;
	}
	for (int k = 0; 2 * k <= a; k += 1)
	{
		int bv = mult(ofacts[k], ofacts[a - k * 2]);
		if (k % 2 == 1)
		{
			bv = mod - bv;
		}
		ma.push_back(bv);
	}
	return ma;
}
int det(vector<vector<int>>&matr)
{
	int n = matr.size();
	for (int i = 0; i < n; i++)
	{
		if (matr[i][i] == 0)
		{
			int cur = 0;
			for (int j = i + 1; j < n; j++)
			{
				if (matr[i][j] != 0)
				{
					cur = j;
					break;
				}
				if (j == n - 1)
				{
					return 0;
				}
			}
			for (int h = 0; h < n; h++)
			{
				int c = matr[i][h];
				matr[i][h] = matr[cur][h];
				matr[cur][h] = c;
			}
		}
		int obr = rev(matr[i][i]);
		for (int j = i + 1; j < n; j++)
		{
			int mt = mult(obr, matr[j][i]);
			for (int h = 0; h < n; h++)
			{
				matr[j][h] = sub(matr[j][h], mult(matr[i][h], mt));
			}
		}
	}
	int dt = 1;
	for (int i = 0; i < n; i++)
	{
		dt = mult(dt, matr[i][i]);
	}
	return dt;
}
int final_ans(vector<int>bv, int turns)
{
	int an = 0;
	for (int i = 0; i < bv.size(); i++)
	{
		int cd = facts[turns - 2 * i];
		cd = mult(cd, facts[turns / 2]);
		cd = mult(cd, ofacts[turns / 2 - i]);
		cd = mult(cd, bv[i]);
		//	cout << i << ' ' << cd << endl;
		an = add(cd, an);
	}
	an = mult(an, bp((mod + 1) / 2, turns / 2));
	return an;
}
int eval(vector<int>&v, int point)
{
	int ans = 0, cur = 1;
	for (int i = 0; i < v.size(); i++)
	{
		ans = add(ans, mult(cur, v[i]));
		cur = mult(cur, point);
	}
	return ans;
}
int slv(vector<int>a, vector<int>b, int n)
{
	int turns = 0;
	for (int i = 0; i < n; i++)
	{
		turns += a[i];
		turns -= b[i];
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if ((a[i] - a[j])*(b[i] - b[j]) < 0)
			{
				return 0;
			}
		}
	}
	if (turns < 0)
	{
		return 0;
	}
	if (turns % 2 == 1)
	{
		return 0;
	}
	vector<vector<vector<int>>>matr(turns / 2 + 1);
	for (int i = 0; i <= turns / 2; i++)
	{
		matr[i].resize(n);
		for (int j = 0; j < n; j++)
		{
			matr[i][j].resize(n);
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			vector<int> bv = getpol(a[i] - b[j]);
			for (int h = 0; h < turns / 2 + 1; h++)
			{
				matr[h][i][j] = mult(eval(bv, h), 1);
				//			cout << h << ' ' << i << ' ' << j << ' ' << matr[h][i][j] << endl;
			}
		}
	}
	//cout << "Here" << endl;
	vector<int>anses(turns / 2 + 1);
	for (int i = 0; i <= turns / 2; i++)
	{
		anses[i] = det(matr[i]);
		//		cout << i << ' ' << anses[i]<<endl;
	}
	//	cout << "Here" << endl;
	anses = interpolate(anses);
	//cout << "Here" << endl;
	int vv = final_ans(anses, turns);
	return vv;
}
int dyn[22][22][22][22][22];
int ez_dyn(vector<int>&a, vector<int>&b, vector<int>&point)
{
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < i; j++)
		{
			if (point[i] == point[j])
			{
				return 0;
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < i; j++)
		{
			point[i]++;
			point[j]++;
			ans = add(ans, dyn[point[0]][point[1]][point[2]][point[3]][point[4]]);
			point[i]--;
			point[j]--;
		}
	}
	return ans;
}
int slv2(vector<int>a, vector<int>b)
{
	dyn[a[0]][a[1]][a[2]][a[3]][a[4]] = 1;
	for (int i1 = 19; i1 >= 0; i1--)
	{
		for (int i2 = 19; i2 >= 0; i2--)
		{
			for (int i3 = 19; i3 >= 0; i3--)
			{
				for (int i4 = 19; i4 >= 0; i4--)
				{
					for (int i5 = 19; i5 >= 0; i5--)
					{
						vector<int>point;
						point.push_back(i1);
						point.push_back(i2);
						point.push_back(i3);
						point.push_back(i4);
						point.push_back(i5);
						if (point != a)
						{
							dyn[i1][i2][i3][i4][i5] = ez_dyn(a, b, point);
						}
					}
				}
			}
		}
	}
	return dyn[b[0]][b[1]][b[2]][b[3]][b[4]];
}
int main()
{
	calc();
	int n;
	cin >> n;
	//	n = 30;
	vector<int>a(n), b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		//	b[i] = i;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		//a[i] = i + 100;
	}
	cout << slv(a, b, n) << endl;;
	cin >> n;
}

