#include <bits/stdc++.h>
using namespace std;

using ull = unsigned long long;
const int bits = 64;

void put (vector<ull> &to_what, const int pos)
{
    to_what[pos >> 6] |= (1ULL << (pos & 63));
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, l, r;
    cin >> n >> l >> r;

    vector<int> a(n);
    for (int &x : a)
        cin >> x;

    const int inf = int(1e9);
    const int maxa = *max_element(a.begin(), a.end());
    const int mina = *min_element(a.begin(), a.end());

    vector<int> dist(r * maxa + 3, inf);
    vector<ull> used_bitset((int(dist.size()) + bits) / bits);
    dist[l * mina] = 0;
    put(used_bitset, l * mina);

    vector<ull> last_bits(bits + 1), first_bits(bits + 1);
    for (int i = 0; i < bits; i++)
        first_bits[i + 1] = (first_bits[i] | (1ULL << i));
    for (int i = bits - 1; i >= 0; i--)
        last_bits[i] = (last_bits[i + 1] | (1ULL << i));

    for (int iter = 0, current_length = 0; iter < 2; iter++)
    {
        queue<int> q;

        for (int i = 0; i < int(dist.size()); i++)
        if (dist[i] <= current_length)
        {
            dist[i] = current_length;
            q.push(i);
        }

        const int target_length = (iter == 0 ? l : r);
        vector<int> transitions = a;

        if (iter == 0)
        {
            for (int &step : transitions)
                step -= mina;
        }

        const int len = *max_element(transitions.begin(), transitions.end()) + 1;
        vector<ull> transitions_bitset((len + 64) / 64);
        for (int step : transitions)
            put(transitions_bitset, step);

        while (!q.empty())
        {
            const int cur = q.front(); q.pop();
            if (dist[cur] == target_length)
                break;

            for (int i = 0; i < int(transitions_bitset.size()); i++)
            {
                // cut segment [cur + i * 64, cur + (i + 1) * 64) from used_bitset
                const int j = i + cur / bits;
                const int len_second = cur % bits;
                const int len_first = bits - cur % bits;
                ull update_mask = (len_first != bits ?
                                   (((used_bitset[j] & last_bits[len_second]) >> len_second) |
                                   ((used_bitset[j + 1] & first_bits[len_second]) << len_first))
                                   :
                                   used_bitset[j]);

                update_mask = (~update_mask) & transitions_bitset[i];

                while (update_mask > 0)
                {
                    const int first_non_zero_bit = __builtin_ctzll(update_mask);
                    update_mask ^= (1ULL << first_non_zero_bit);

                    const int dest = cur + i * bits + first_non_zero_bit;

                    assert(dest <= r * maxa);
                    assert(dist[dest] == inf);
                    dist[dest] = dist[cur] + 1;
                    put(used_bitset, dest);
                    q.push(dest);
                }
            }
        }

        current_length = target_length;
    }

    cout << count_if(dist.begin(), dist.end(), [&] (int x) {return x <= r;}) << endl;
}
